#!/usr/local/bin/perl -w

#CS8761, Fall 2002
#Group Project
#Bigmac dictionary Interface module
#Group-   Sport Boys
#         Aniruddha Mahajan
#         Anushree Parsekar
#         Prashant Rathi
#         Victoria Harp 
#This is a sample Program to use the bigmac module and understand the different functionality it provides.




use bigmac;                                                                       #module to be used

sub menu_display();                                                                  #functions used to create menu and sub-menu displays 
sub sub_display();
 

print " This may take time ...Please wait\n"; 

get_hash();                                                                          #this function is the first function which has to be called
print "\nOK\n";                                                                      #compulsarily to get the data in a hash for speedy access in future
menu_display();
TOP:                                                                                 #Label
print "Enter option: ";                                                              #Ask the user for the functionality desired
$option=<STDIN>;
if($option ==0 )    
{
    exit(0);                                                                         #Quit Option
}
if($option == 1)                                                                     #Option 1 
{ 
    print "\nEnter word: " ;                                                         #This returns all the information about a particular word
    $word =<STDIN>;
    $result= get_word_info($word);                                                   #Pronunciation,Word definitions,Parts of Speech,Inflections
    $result =~ s/<(.*?)>//g;
    sub_display();                                                                   #Synonyms and the Language entries are returned 
    $display=<STDIN>;
    chomp($display);
    if($display eq 'T' | $display eq 't')                                            #Display on terminal
    {   
	print $result;
        print "\nPRESS ENTER TO CONTINUE....";
        <STDIN>;
	menu_display();
        goto TOP;
    }
    if($display eq 'F' | $display eq 'f')                                            #Print to file option
    {            
	print "\nFilename:";
	$filename =<STDIN>;
	open(FILE,">$filename");
        print FILE $result;
        close(FILE);
        print "\nOK\n";
        menu_display();
        goto TOP;
    }
    
    
}
if ($option==2)                                                                      #This option produces a list of all nouns,verbs,adjectives, adverbs
{                                                                                    #and prints them in the files desired
    print "\n***************************************************************\n";
    print "*               PARTS OF SPEECH                               *\n";
    print "*                                                             *\n";
    print "*               1 -- Nouns                                    *\n";
    print "*               2 -- Verbs                                    *\n";
    print "*               3 -- Adjectives                               *\n";
    print "*               4 -- Adverbs                                  *\n";
    print "*               0 -- Quit                                     *\n";
    print "***************************************************************\n";
    print "\n Enter: ";                                                              #Get the filename from the user
    $pos=<STDIN>;
    print "\nFilename:";
    $filename =<STDIN>;
    open(FILE,">$filename");
    print("\nWork in Progress\n");    
    if($pos == 1)
    {        
        %result = get_nouns();                                                       # Nouns
    }
    if($pos == 2)
    {        
        %result = get_verbs();                                                       # Verbs
    }
    if($pos == 3)
    {
        %result = get_adjectives();                                                  # Adjectives
    }
    if($pos == 4)
    {
        %result = get_adverbs();                                                     # Adverbs
    }
    foreach $x(keys %result)
    {       
        print FILE "$x\n";
    }    
    print "\nOK\n";
    close(FILE);                  
    <STDIN>;
    menu_display();
    goto TOP;
}

if($option ==3)
{
    print "\nEnter the words separated by space: ";                                   #User Enters a set of words separated by space
    $query_string = <STDIN>;
    chomp($query_string);                                                           
    @query= split/ /,$query_string;
    print("\nWork in Progress\n"); 
    $val = get_defn(@query);                                                          # Function returns all the defintions in which these words occur  
    print"\nOK\n";
    sub_display();
    print "\nENTER: ";
    $display=<STDIN>;
    chomp($display);
    if($display eq 'T' | $display eq 't')                                             # Print to the terminal
    {
	print $val;
        print "\nPRESS ENTER TO CONTINUE....";
        <STDIN>;
	menu_display();
        goto TOP;
    }
    if($display eq 'F' | $display eq 'f')                                             # Print to the File
    {
	print "\nFilename:";
	$filename =<STDIN>;
	open(FILE,">$filename");
        print FILE $val;
        close(FILE);
        print "\nOK\n";
        menu_display();
        goto TOP;
    } 
}

if($option==4)                                                                        # This option returns the all similar thes code entries   
{
    print "\nEnter word: " ;
    $word =<STDIN>;                                                                   # Enter the word whose thes codes are to be matched
    print("\nWork in Progress\n"); 
    $result = get_by_value($word);
    print $result;
    menu_display();
    goto TOP;
}

#Function to display the main menu with different options
sub menu_display() 
{
    print "***************************************************************\n";
    print "*                                                             *\n";
    print "*               USING THE BIGMAC INTERFACE                    *\n";
    print "*                                                             *\n";
    print "***************************************************************\n";
    
    print "\n***************************************************************\n";  
    print "*               MENU OPTIONS                                  *\n";
    print "*                                                             *\n";
    print "*               1 -- Word Query                               *\n";
    print "*               2 -- List by parts of speech                  *\n";
    print "*               3 -- Search definitions by set of words       *\n";
    print "*               4 -- Words with the same code or value        *\n";
    print "*               0 -- Quit                                     *\n";
    print "***************************************************************\n"
    }


#Function to display the sub-menu
sub sub_display()
{
    print "\n***************************************************************\n";
    print "*               DISPLAY OPTIONS                               *\n";
    print "*                                                             *\n";
    print "*               F -- Print to file                            *\n";
    print "*               T -- Print to terminal                        *\n";
    print "***************************************************************\n"
}

