#!/usr/local/bin/perl -w

#CS8761, Fall 2002
#Group Project
#Bigmac dictionary Interface module
#Group-   Sport Boys
#         Aniruddha Mahajan
#         Anushree Parsekar
#         Prashant Rathi
#         Victoria Harp   


#This program is used to test the module installation
#It tests the various functions provided in the module
#Tests 1-10 test the different words and their query result
#Tests 11- 15 test the results when an array of words is searched for in all definitions
#Tests 16-20 test the results when a word is input and all the words with similar values are displayed

use bigmac;

get_hash();
print "\n Testing .. Please wait.......\n";

#----Test1-----
$word = "partisan";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;
$correct_answer="HEADWORD--partisanPRON----'pahtuhzuhnPRON----pahtuh'zanPRON----'pahtuhzuhnPARTOFSPEECH--nounDEFINITION:--anadherentorsupporterofaperson,party,orcause.--amemberofapartyoflightorirregulartroops,especiallyasformingtheindigenousarmedresistancetoaninvaderorconqueror;aguerilla.PARTOFSPEECH--adjectiveDEFINITION:--relatingtoorcarriedonbymilitarypartisans.--excessivelydedicatedtoacauseorparty.--biased;prejudiced.PARTOFSPEECH--nounDEFINITION:--ashaftedweaponwithbroadbladeandcurvedbasallobes,especiallycarriedbybodyguards.RelatedWords:standard-bearerapttoundeservedprejudiceassegaiLANG:----French----Italian----Latin";
if($answer eq $correct_answer)
{
    print "TEST 1 OK \n";
}
else
{
    print "TEST 1 failed \n";
}

#----Test 2-----
$word = "abash";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;
$correct_answer="HEADWORD--abashPRON----uh'bashPARTOFSPEECH--verb(t)DEFINITION:--todestroytheself-possessionof;makeashamedorembarrassedRelatedWords:humblehumilityLANG:----MiddleEnglish----Anglo-French----variant----OldFrench";
if($answer eq $correct_answer)
{
    print "TEST 2 OK \n";
}
else
{
    print "TEST 2 failed \n";
}

#------Test 3 ----
$word = "expel";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;
$correct_answer="HEADWORD--expelPRON----uhk'spelPRON----ek-PRON----ekspel'eeINFLECTION--expelledINFLECTION--expellingPARTOFSPEECH--verb(t)DEFINITION:--todriveorforceoutoraway;dischargeoreject--tocutofffrommembershiporrelationsRelatedWords:expelexpellerLANG:----MiddleEnglish----Latin";
if($answer eq $correct_answer)
{
    print "TEST 3 OK \n";
}
else
{
    print "TEST 3 failed \n";
}

#----Test 4----
$word = "aberrant";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;
$correct_answer= "HEADWORD--aberrantPRON----'abuhruhntPRON----uh'beruhntPARTOFSPEECH--adjectiveDEFINITION:--strayingfromtherightorusualcourse.--deviatingfromtheordinaryornormaltype.RelatedWords:exceptionaldeflectiveexceptionalimmoralityfreakimmoralityfreakaberranceindirectnessLANG:----Latin";
if($answer eq $correct_answer)
{
    print "TEST 4 OK \n";
}
else
{
    print "TEST 4 failed \n";
}
#----Test 5---
$word = "profane";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;
$correct_answer="HEADWORD--profanePRON----pruh'faynINFLECTION--profanedINFLECTION--profaningPARTOFSPEECH--adjectiveDEFINITION:--characterisedbyirreverenceorcontemptforGodorsacredthings;irreligious,especiallyspeakingorspokeninmanifestorimpliedcontemptforsacredthings.--notsacred,ornotdevotedtosacredpurposes;unconsecrated;secular--unholy;heathen;pagan.--notinitiatedintoreligiousritesormysteries,aspersons.--commonorvulgar.PARTOFSPEECH--verb(t)DEFINITION:--tomisuse(anythingthatshouldbeheldinreverenceorrespect);defile;debase;employbaselyorunworthily.--totreat(anythingsacred)withirreverenceorcontempt.RelatedWords:sinfulbanausicbanausicblistercoyLANG:----MiddleEnglish----French----Latin";
if($answer eq $correct_answer)
{
    print "TEST 5 OK \n";
}
else
{
    print "TEST 5 failed \n";
}

#---Test 6---
$word = "voluptuous";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;

$correct_answer="HEADWORD--voluptuousPRON----vuh'lupchoohuhsPARTOFSPEECH--adjectiveDEFINITION:--fullof,characterisedby,orministeringtopleasureorluxuriousorsensualenjoyment--derivedfromluxuriousorfullgratificationofthesenses--directedtowardsluxuriousorsensualenjoyment--givenorinclinedtoluxuriousenjoymentofthepleasuresofthesenses--suggestiveofaninclinationtosensualpleasure--sensuallypleasingordelightful--(ofthefemalefigure)curvaceous.RelatedWords:voluptuousalluringelegantsexyradiantlyvoluptuousnessvoluptuousnessvoluptuousnessvoluptuousnessLANG:----MiddleEnglish----Latin";
if($answer eq $correct_answer)
{
    print "TEST 6 OK \n";
}
else
{
    print "TEST 6 failed \n";
}

#---Test 7----
$word = "mortify";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;

$correct_answer="HEADWORD--mortifyPRON----'mawtuhfuyINFLECTION--mortifiedINFLECTION--mortifyingPARTOFSPEECH--verb(t)DEFINITION:--tohumiliateinfeeling,asbyaseverewoundtotheprideorself-complacency.--tobring(thebody,passions,etc.)intosubjectionbyabstinence,asceticdiscipline,orrigorousausterities.--toaffectwithgangreneornecrosis.PARTOFSPEECH--verb(i)DEFINITION:--toundergomortification,orbecomegangrenedornecrosed.PARTOFSPEECH--phraseDEFINITION:--topractisemortificationordisciplinaryausterities.RelatedWords:humblerashlybrashLANG:----MiddleEnglish----OldFrench----LateLatin";
if($answer eq $correct_answer)
{
    print "TEST 7 OK \n";
}
else
{
    print "TEST 7 failed \n";
}

#---Test 8-----
$word = "nomadic";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;
$correct_answer="HEADWORD--nomadicPRON----noh'madikPARTOFSPEECH--adjectiveDEFINITION:--of,relatingto,orcharacteristicofnomads.RelatedWords:LANG:";
if($answer eq $correct_answer)
{
    print "TEST 8 OK \n";
}
else
{
    print "TEST 8 failed \n";
}

#---Test 9-----
$word = "wily";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;
$correct_answer="HEADWORD--wilyPRON----'wuyleeINFLECTION--wilierINFLECTION--wiliestPARTOFSPEECH--adjectiveDEFINITION:--fullof,markedby,orproceedingfromwiles;crafty;cunning.RelatedWords:cunningcraftinessLANG:----MiddleEnglish";
if($answer eq $correct_answer)
{
    print "TEST 9 OK \n";
}
else
{
    print "TEST 9 failed \n";
}

#---Test 10----
$word = "girth";
$answer = get_word_info($word);
$answer =~ s/<(.*?)>//g;
$answer =~ s/\s+//g;
$correct_answer="HEADWORD--girthPRON----gerthPARTOFSPEECH--nounDEFINITION:--themeasurearoundanything;circumference.--abandpassedunderthebellyofahorse,etc.,tosecureasaddleorpackonitsback.--abandorgirdle.PARTOFSPEECH--verb(t)DEFINITION:--tobindorfastenwithagirth.--togirdle;encircle.RelatedWords:beltharnessLANG:----MiddleEnglish----Scandinavian----Icelandic";
if($answer eq $correct_answer)
{
    print "TEST 10 OK \n";
}
else
{
    print "TEST 10 failed \n";
}

#--- Test 11----
@words = ("repeat","in");
$answer =  get_defn(@words);
$answer =~ s/\s+//g;

$correct_answer ="HEADWORD-----recapitulatePOS----verb(t)DEFN----(ofayounganimal)torepeat(ancestralevolutionarystages)initsdevelopment.HEADWORD-----retailPOS----verb(t)DEFN----torelateorrepeatindetailtoothersTHESENTRIES--strewHEADWORD-----chimePOS----verb(t)DEFN----toutterorrepeatincadenceorsingsong.HEADWORD-----ringPOS----phraseDEFN----tovarythemannerofperforminganaction;repeatinvaryingorder.THESENTRIES--modulateHEADWORD-----recitePOS----verb(t)DEFN----torepeatthewordsof,asfrommemory,especiallyinaformalmannerHEADWORD-----recurPOS----verb(i)DEFN----torepeatafixedsetofoneormoredigitsinadecimal.HEADWORD-----replicatePOS----verb(t)DEFN----torepeat(ascientificexperiment)inordertoverifyitsconclusions.HEADWORD-----patterPOS----verb(i)DEFN----torepeatthepaternosteroranyprayer,etc.,inarapid,mechanicalway.HEADWORD-----patterPOS----verb(t)DEFN----toreciteorrepeat(prayers,etc.)inarapid,mechanicalway.HEADWORD-----makePOS----phraseDEFN----torepeat(acourseorexaminationinwhichonehasfailed)ortotake(anexaminationfromwhichonehasbeenabsent).HEADWORD-----cyclePOS----nounDEFN----aroundofyearsorarecurringperiodoftime,especiallyoneinwhichcertaineventsorphenomenarepeatthemselvesinthesameorderandatthesameintervals.THESENTRIES--sequence";
if($answer eq $correct_answer)
{
    print "TEST 11 OK \n";
}
else
{
    print "TEST 11 failed \n";
}

#---Test 12----
@words = ("terminate","in");
$answer =  get_defn(@words);
$answer =~ s/\s+//g;

$correct_answer="HEADWORD-----restPOS----verb(i)DEFN----toterminatevoluntarilytheintroductionofevidenceinacase.HEADWORD-----resultPOS----verb(i)DEFN----toterminateorendinaspecifiedmannerorthing.HEADWORD-----issuePOS----phraseDEFN----toendin;terminatein.";
if($answer eq $correct_answer)
{
    print "TEST 12 OK \n";
}
else
{
    print "TEST 12 failed \n";
}
#---Test 13----
@words = ("go","away","from");
$answer =  get_defn(@words);
$answer =~ s/\s+//g;

$correct_answer="HEADWORD-----leavePOS----verb(t)DEFN----togoawayfrom,departfrom,orquit,asaplace,aperson,orathing.THESENTRIES--departabscondresignHEADWORD-----departPOS----verb(i)DEFN----togoaway,asfromaplace;takeone'sleave.THESENTRIES--departexit";
if($answer eq $correct_answer)
{
    print "TEST 13 OK \n";
}
else
{
    print "TEST 13 failed \n";
}

#---Test 14----
@words = ("last","for");
$answer =  get_defn(@words);
$answer =~ s/\s+//g;

$correct_answer="HEADWORD-----blinkPOS----phraseDEFN----(aphraseindicatingthatsomethingwilllastforaveryshorttime).HEADWORD-----terminatingbuildingsocietyPOS----nounDEFN----anassociationofindividualswhomakeregularpaymentstoacommonfund,fromwhicheachobtainsahousingloan,theorderusuallybeingdeterminedbyballot;thesocietyisterminatedwhenthelasthouseispaidfor.THESENTRIES--bankHEADWORD-----postPOS----nounDEFN----eitheroftwobuglecalls(firstpostandlastpost)givingnoticeofthehourforretiring,asforthenight.HEADWORD-----eleventhhourPOS----nounDEFN----thelastpossiblemomentfordoingsomething.THESENTRIES--lastminuteHEADWORD-----semipermanentPOS----adjectiveDEFN----intendedtolastforsometimebutnotforever,asapositionsubjecttoreview,oradyethatwillwashoutafterfrequentwashingorspecialtreatment.HEADWORD-----FatimaPOS----nounDEFN----theseventhandlastwifeofBluebeard,popularlyasymbolforfemininecuriosity.HEADWORD-----firmwarePOS----nounDEFN----programsfixedintoacomputer'smemory,whichcannotbealteredwithoutchangingthehardware,especiallysubroutineswhicharetolastforthelifeofthecomputer.THESENTRIES--SOFTWARE:HEADWORD-----balladePOS----nounDEFN----apoemconsistingcommonlyofthreestanzashavinganidenticalrhymescheme,followedbyanenvoy.Thesamelastlineisusedforeachofthestanzasandenvoy.HEADWORD-----OrpheusPOS----nounDEFN----aThracianpoetandmusician,asonofApolloandCalliope.HefollowedhisdeadwifeEurydicetoHadesandwasallowedbyPluto,whomhehadcharmedbyhismusic,toleadherout,providedthathedidnotlookbackather.Atthelastmomenthedidso,andshewaslosttohimforever.HEADWORD-----complinePOS----nounDEFN----thelastofthesevencanonicalhours,ortheserviceforit,occurringoriginallyaftertheeveningmealbutmorerecentlyaftervespers.HEADWORD-----daylilyPOS----nounDEFN----anyplantofthegenusHemerocallis,withyellowororangeflowerswhichcommonlylastonlyforaday.";
if($answer eq $correct_answer)
{
    print "TEST 14 OK \n";
}
else
{
    print "TEST 14 failed \n";
}

#---Test 15-----

@words =("great","work");
$answer = get_defn(@words);
$answer =~ s/\s+//g;

$correct_answer="HEADWORD-----megalithPOS----nounDEFN----astoneofgreatsize,especiallyinancientconstructiveworkorinprimitivemonumentalremains(asmenhirs,dolmens,cromlechs,etc.).THESENTRIES--giantstalactiteHEADWORD-----magnumopusPOS----nounDEFN----agreatworkTHESENTRIES--workofart";
if($answer eq $correct_answer)
{
    print "TEST 15 OK \n";
}
else
{
    print "TEST 15 failed \n";
}

#---Test 16-----

$word="filth";
$answer=get_by_value($word);
$answer =~ s/\s+//g;

$correct_answer="121.02.10grotsoilmessdirtdirtfilthtoejamgrimemuck";
if($answer eq $correct_answer)
{
    print "TEST 16 OK \n";
}
else
{
    print "TEST 16 failed \n";
}

#--- Test 17-----
$word="rogue";
$answer=get_by_value($word);
$answer =~ s/\s+//g;

$correct_answer="070.05.10misconductoattempercarrycarrystraighttrespasslapseactmisbehaveastrayroguecutplaygoodmuckblackguardshort532.03.10prodigymonstrositymutationodditybastardfishsportfreakoddchimeragrotesqueperversionmonstergrotesqueriequip187.05.10palmpalmswindleswindledefraudswizzlefudgerookdiddleringboltconsmugglesmugglecheattakegyppointbubblejockeyjockeyshort-changecozenhoozlesuckbeatflim-flamcogtrickfinaglestinghotpointeyetrepanchiselchiselslantercullybitebrassnickoverreachmountebankbilkclipwelshdodoquackfob767.01.80outcastdrummertoe-raggerswaggiehobobumswagmanstreetArabswaggervagbattlerwhalerdeadbeatsundownervagabondMurrumbidgeewhalerbeachcomberoverlandertrampbagmancoilervagrant070.03.10scallywaggremlinimpelfmonkeypicklemuck-upscampjackanapesprankstermischief-maker370.02.10crookracketeerrascaldodgerfakercorruptfaketwisteradventurersharkratbagfraudknaveadventuresswrong'unwangle";
if($answer eq $correct_answer)
{
    print "TEST 17 OK \n";
}
else
{
    print "TEST 17 failed \n";
}

#--Test 18----
$word="slam";
$answer=get_by_value($word);
$answer =~ s/\s+//g;


$correct_answer="276.04.30objurgateassailthrowabuseattackslurbullyragpersonalslatefulminatebashstucksniperevilevituperateslaglashslamexcoriatebelabour366.10.40bangknockwhamwhangthudslayrapthump028.04.30sloughtripletlittleslamtenacebookfourofakindsweepsquaredealwidowWhitechapelmeldroutinestraightdoublemis&egrave;restopYarboroughredoublerubbersequenceroyalroutinediscardroundno-trumperfullhousetrickcrossruffgrandslamfinesseseesawre-entryquicktrickfour-flushmakeflushovertrickroyalflushpairundertrickgoulashruff039.02.20rubdressing-downkicktrimmingroastingblastfleajawlashingpastingrazzcounterblasttalking-toservepayoutkitchenwiggingbaggingtongue-lashchipratingslaproastmindrockettreatmentscorcherbasherearful251.01.60bangpoundpopboomcrumpclapsmashpealwhiz-bangcrackthundercrash039.06.30panscathetearboopooh-poohslatebagscorchvituperatecriticiseroastmonstercanvassscorescarify251.09.30bangbarkthunderthump366.03.20hurtlebangcrack-upbumpthudstackclashconflictcollisionelasticcollision";
if($answer eq $correct_answer)
{
    print "TEST 18 OK \n";
}
else
{
    print "TEST 18 failed \n";
}

#--Test 19----
$word="limit";
$answer=get_by_value($word);
$answer =~ s/\s+//g;


$correct_answer="033.02.30troubleproblemlimitworrystrawdifficulty140.03.10stipulatestipulatequalifyprovideconditioncondition213.01.80borderlineboundarycoastRubiconoutskirtsmarchfrontier213.11.10containdrawdelimitterminatecircumscribelinedefineconscribe638.09.20rationstraitenpegstint619.01.10localeredevelopmentareascopequartertractneighbourhoodregionvicinageextentnaturalregionpalecountrydistrictzoneswathlocalityzonuleprecinctlocationcornerrestrictedareanecktimezonelandblockprovincestretch213.02.10measurelimitmete";
if($answer eq $correct_answer)
{
    print "TEST 19 OK \n";
}
else
{
    print "TEST 19 failed \n";
}

#--Test 20 ----
$word="query";
$answer=get_by_value($word);
$answer =~ s/\s+//g;

$correct_answer="104.02.20mysterymysterymysteryriddleriddlequerypuzzleobscurequestionobscurityobscurityenigma074.04.30challenge";
if($answer eq $correct_answer)
{
    print "TEST 20 OK \n";
}
else
{
    print "TEST 20 failed \n";
}


#--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
