#!/usr/local/bin/perl -w

#CS8761, Fall 2002
#Group Project
#Group-   Sport Boys
#         Aniruddha Mahajan 
#         Anushri Parsekar
#         Prashant Rathi
#         Victoria Harp 
#Stage 3
#
# SENTIMENT CLASSIFICATION PROGRAM - FINAL
#


use BigMac::bigmac;                                                   # Using the modules for dictionary 
use LDOCE::ldoce;                                                    # and web interfaces  
use WebReader::vista;

sub call_directory;                                           # function declaration  

$good_cache_file ="sb_good_cache.txt";                           # File Names for the cached- data.
$bad_cache_file ="sb_bad_cache.txt";
print "Please wait...\n";      
$directory = $ARGV[0];                                        # Accept path/name of directory containing reviews
createhash();                                                 # LDOCE : function createhash to create hash of words from LDOCE
get_hash();                                                   # BIGMAC : create hash from bigmac

open(SEED,"seed_words.txt");                                  # Open the seed_words file to get the baseline words 
$good_word = <SEED>;                                          # the baseline word for 'good'
$bad_word=<SEED>;                                             # the baseline word for 'bad' 
close SEED;

# LDOCE - used to find a separate list of good and bad words 

$ldoce_answer = words_in_defs($good_word);                    # call to LDOCE fn to make good-word list 
$ldoce_answer =~ s/-//g;                                      # this function finds all the words whose definitions            
$ldoce_answer =~ s/\s+/ /g;                                   # contain these baseline words.   
@array = split / POS /,$ldoce_answer;                             
for($i=1;$i<@array;$i+=2)
{
    @odd_words = split / /,$array[$i];                        # From these words only adjectives are stored in a hash for LDOCE good words
    if($odd_words[0] eq 'adj')                                # They are used while calculating factor values.
    {
	@even_words= split / /,$array[$i-1];
	$ldoce_good_hash{$even_words[$#even_words]}++;
    }  
		  
}	

$ldoce_answer = words_in_defs($bad_word);                     # call to LDOCE fn to make bad-word list
$ldoce_answer =~ s/-//g;                                      # this function finds all the words whose definitions
$ldoce_answer =~ s/\s+/ /g;                                   # contain these baseline words   
@array = split / POS /,$ldoce_answer;                             
for($i=1;$i<@array;$i+=2)
{
    @odd_words = split / /,$array[$i];
    if($odd_words[0] eq 'adj')                                # From these words only adjectives are stored in a has for LDOCE bad words  
    {                                                         # They are used while calculating factor values  
	@even_words= split / /,$array[$i-1];
	$ldoce_bad_hash{$even_words[$#even_words]}++;
    }  
		  
}	


# BigMac creates it own list of good and bad words

$answer = get_by_value($good_word);                           # This function of BigMac returns all the synonyms ( sharing the same thes code)
$answer =~ s/[0-9]//g;                                        # for the baseline word (good_word)
$answer =~ s/\.//g; 
$answer =~ s/\s+/ /g;
@matches = split / /,$answer;
$j=0;
open(GOOD,">good.txt")or die "can't open file";               # This list is a main list of good words and hence stored in a file
for($i=0;$i<@matches;$i++)
{
    $mark =get_pos($matches[$i],"adjective");
    if($mark == 1)
    {
	if(!($matches[$i] eq "bad")  or  !($matches[$i] eq "up")) # Again adjectives are chosen only, some unwanted words are removed 
	{
	    $goodarr[$j] =$matches[$i];                           # The good list is stored in an array
	    print GOOD "\n$matches[$i]";
	    $j++;
	}
    }
}

$answer = get_by_value($bad_word);                     # This function of BigMac returns all the synonyms ( sharing the same thes code)
$answer =~ s/[0-9]//g;                                         # for the baseline word (bad_word)
$answer =~ s/\.//g; 
$answer =~ s/\s+/ /g;
@matches = split / /,$answer;open(BAD,">bad.txt");             # This list is a main list of bad words and hence stored in a file
$j=0;
for($i=0;$i<@matches;$i++)                              
{
    $mark =get_pos($matches[$i],"adjective");                  # Choosing adjectives for the bad list
    if($mark == 1)
    {
	$badarr[$j] =$matches[$i];
        print BAD "\n$matches[$i]";                            # The bad list is stored in an array
        $j++;
    }
} 
$badarr[$j]="no";                                              # Storing important words which signify negation in the bad words array
$badarr[$j+1]="not";
$badarr[$j+2]="nothing";



if(-e $good_cache_file)
{
    open(CACHE1,"$good_cache_file");                           # Initialise GOOD cache
    while($line =<CACHE1>)                                     # This cache file is used for multiple program runs and         
    {                                                          # hence it improves execution speed
	@data_pair = split/ /,$line;                           
	$good_cache{$data_pair[0]}++;
	$factor_cache{$data_pair[0]}=$data_pair[1];            # Storing the good words and its weighing factor (from web)
    }                                                          # in the cache
}
close CACHE1;
if( -e $bad_cache_file)                                        # Initialise BAD cache
{                                                              # This cache file is used for multiple program runs and 
    open(CACHE2,"$bad_cache_file");                            # hence it improves execution speed
    while($line =<CACHE2>)                                              
    {
	@data_pair = split/ /,$line;
	$bad_cache{$data_pair[0]}++;
	$factor_cache{$data_pair[0]}=$data_pair[1];            # Storing the good words and its weighing factor (from web)
    }                                                          # in the cache
}
close CACHE2;

print "Data Creation Done......\n";

# Data neccessary for further use is now created and now the classification algorithm begins
                                                                       
open(TRACE,">trace.txt");                                     # This file will store the computations and the detected good or bad
$i = 0;                                                        # words for each review
$file_count =0;
$pos_dir = $directory."/pos";                                  # Path for negative and positive sub-directories
$neg_dir = $directory."/neg";
$positive=0;
$negative=0;
$no_decision=0;

opendir(NEGDIR,$neg_dir);                                      # Open the negative directory for negative files
while (defined ($file = readdir NEGDIR))
{
    call_directory(1);                                         # Process each file in the directory
}
print TRACE "POS--> $positive, NEG--> $negative , UNDECIDED --> $no_decision\n";     
$neg_accuracy = $negative;                                     # Check the count for no. of files classified as negative
$positive=0;
$negative=0;
$total_undecided = $no_decision ;
$no_decision=0;                                      
close NEGDIR;                                                  

opendir(POSDIR,$pos_dir);                                      # Open the positive directory for positive files
while (defined ($file = readdir POSDIR))
{
    call_directory(0);                                         # Process each file in the directory
}

print TRACE  "POS--> $positive, NEG--> $negative , UNDECIDED --> $no_decision\n";      
$pos_accuracy = $positive;                                     # Check the count for no. of files classified as positive
$total_undecided += $no_decision;

open(CACHE1,">$good_cache_file");                              # update the cache file for good cache
foreach $x(keys %good_cache)
{
    print CACHE1 $x;                                           # Store the good-word
    print CACHE1 " ";
    print CACHE1 "$factor_cache{$x} \n";                       # Store the hit-factor from the web
}
close CACHE1; 

open(CACHE2,">$bad_cache_file");                               # update the cache file for bad cache
foreach $x(keys %bad_cache)
{
    print CACHE2 $x;                                           # Store the bad word
    print CACHE2 " ";
    print CACHE2 "$factor_cache{$x} \n";                       # Store the hit-factor from web
}
close CACHE2; 

print "\nFor a total of $file_count reviews  --->";
$precision = ($pos_accuracy + $neg_accuracy)/($file_count - $total_undecided); # Calculate the precision
$recall = ($pos_accuracy+$neg_accuracy)/$file_count;           # Calculate the recall 
$f_score = ((2 * $precision * $recall) /($precision + $recall));# Calculate the f-score
close POSDIR;

printf "\n Precision :: %6.4f\n",$precision;                            # Print the results
printf "\n Recall :: %6.4f\n",$recall; 
printf "\n F-Score :: %6.4f\n",$f_score; 



# This is the function which processes all the files in the sub-directories (either positive or negative)
sub call_directory
{
    $dirflag= $_[0];
    $max = 10;                                                 # Threshold or limting factor for the hits factor got from the web
    if($dirflag==0)                   
    {
	return if $file=~ /^\.\.?$/;                           # ignore unnecessary files from the directory
	$file_count++;
	print "\n\n$pos_dir/$file ===>\tPOSITIVE\t";           # Open the positive review
	print  TRACE "\n\n$pos_dir/$file ===>\tPOSITIVE\n";
	open(REVIEW,"$pos_dir/$file") or die "can't open file";
    }
    else
    {
	return if $file=~ /^\.\.?$/;                           # ignore unnecessary files from the directory
        $file_count++;
	print "\n\n$neg_dir/$file ===>\tNEGATIVE\t";
	print TRACE "\n\n$neg_dir/$file ===>\tNEGATIVE\n";     # Open the negative review 
	open(REVIEW,"$neg_dir/$file") or die "can't open file";	
    }
    $good_cnt=0;                                               # Initialise the good and the bad counts.
    $bad_cnt=0;
    $reviewline ='';
    while($line =<REVIEW>)                                     # Store the entire file as a single line 
    {
	$reviewline.=$line;
    }
    $reviewline =~ s/[^a-zA-Z0-9 ]//g;                         # remove all punctuation
    $reviewline =~ s/\s+/ /g;                                  # replace multiple spaces by a single space
    open(STOP,"stop_words.txt");
    while($stop_word =<STOP>)                                  # removing the stop words from the file
    {
	chomp($stop_word);
	$reviewline =~ s/ $stop_word / /g;
    }
    close STOP;                                                 
    $reviewline =~ s/\s+/ /g;                                  # replace multiple spaces by a single space
    @reviewarr = split/ /, $reviewline;                        # split the review into words 
    %hash=();                                                  # Initializing the hashes - two hashes are used
    %no_hash=();                                               # one hash contains words with 'no' or 'not' near them
    for($l=0;$l<@reviewarr;$l++)                               # the other hash is normal one
    {  
	if($reviewarr[$l-1] eq 'not' | $reviewarr[$l-1] eq 'no' | $reviewarr[$l-2] eq 'not' | $reviewarr[$l-2] eq 'no')
        {
	    $no_hash{$reviewarr[$l]}++;                        # nohash : hash containing $k if not '$k  or no '$k' occurs
	}                                                      # e.g.   not 'good'  increases badcount    
	else
	{
            if(!($reviewarr[$l] eq "not") or ($reviewarr[$l] eq "no"))
            {
		$hash{$reviewarr[$l]}++;                       # other words are stored in the normal hash
	    }
	}
    }

    # Processing the review which is now divided into two hashes
    foreach $k(keys %hash)                                     # All words in the normal hash are considered
    {   
	if(exists $good_cache{$k})                             # If the word is found in the cache for good words   
	{
            print TRACE "\nword = $k ";                        # we get the factor from the cache itself
	    $ff = 1;                                           # hence WebReader module is not needed
	    $good_cnt += $factor_cache{$k};
	    print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
	    print TRACE "   goodword = $k ";                   # Output details to the trace file.
	    next;
        }
	if(exists $bad_cache{$k})                              # If the word is found in the cache for bad words 
	{
	    print TRACE "\nword = $k ";
	    $ff = 1;                                           # we get the factor from the cache itself
	    $bad_cnt += $factor_cache{$k};                     # hence WebReader module is not needed
	    print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
	    print TRACE "   badword = $k ";                    # Output details to the trace file.
	    next;
        }	       		    
        $ff = 0;
        for($ll=0;$ll<@goodarr;$ll++)
        {
             if($k eq $goodarr[$ll])                           # if word directly matches goodlist word
             {
		 print TRACE "\nword = $k ";
                 $ff = 1;                                  
		 $good_cache{$k}++;
		 $result = get_hits($k,$goodarr[$ll]);     # use of the WEB-READER interface to get no.of hits
		 $result =~ s/,//g;                            # no. of hits are found for the word NEAR goodword (the one it matches) 
                 $factor = 1;
                 if($result ne "")
		 {$factor = $result/100000;}
		 if(exists $ldoce_good_hash{$k}) {$factor *=2;}# if that good-word exists in the LDOCE hash then the factor is doubled
                 if($factor > $max ) {$factor=$max;}           # Check the factor for the threshold value
		 $factor_cache{$k} = $factor;
		 $good_cnt += $factor;                         # Increment the good-count
		 print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
		 print TRACE "   goodword = $k ";              # Output details to the trace file.
		 last;
             }
	}
        for($ll=0;$ll<@badarr;$ll++)                           # if word directly matches badlist word
        {
             if($k eq $badarr[$ll])
             {
		 print TRACE "\nword = $k ";
                 $ff = 1;
		 $bad_cache{$k}++;
		 $result = get_hits($k,$badarr[$ll]);      # use of the WEB-READER interface to get no.of hits
		 $result =~ s/,//g;                            # no. of hits are found for the word NEAR badword (the one it matches) 
                 $factor = 1;
                 if($result ne "")
		 {$factor = $result/100000;}
		 if(exists $ldoce_bad_hash{$k}) {$factor *=2;} # if that bad-word exists in the LDOCE hash then the factor is doubled
		 if($factor > $max ) {$factor=$max;}           # Check the factor for the threshold value
		 $factor_cache{$k} = $factor;
		 $bad_cnt += $factor;                          # Increment the good-count
		 print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
		 print TRACE "   badword = $k ";               # Output details to the trace file
		 last;
             }
             
	}
        if($ff == 0)                                           # if no direct match is seen
        {   
	    $ans = get_word_info($k);
	    $ans =~ s/\s+/ /g;
	    $def = '';
	    $part = '';
	    $ans1 = $ans;
	    while($ans1 =~ m/<POS>(.*?)<\/POS>/)              #find the part of speech of the word
	    {
		$part .= $&; 
		$ans1 = $'; #'
	    }
	    if($part =~ m/<POS>adjective<\/POS>/ or $part =~ m/<POS>adverb<\/POS>/)        #check if the word is adjective or adverb
	    {   
                if(!($part=~ m/<POS>verb<\/POS>/))                      # do not consider verbs
                {   
		    print TRACE "\nword = $k ";
		    if($ans =~ m/<RELATED>(.*?)<WORDS>/)                #split the definition of the word
		    {                                                   #Get the related words (words with same thes code) 
			$def .= $1;	
		    }
		    $def =~ s/\s+/ /g;                    
		    $deaf = $def;
		    $flag=0;
		    for($i=0;$i<@goodarr;$i++)                         
		    {
			if($flag==0)
			{
			    if($def =~ m/ $goodarr[$i] /)          #compare related words with goodword list   
			    {   
				
				$good_cache{$k}++; 
				$result = get_hits($k,$goodarr[$i]);   # use of the WEB-READER interface to get no.of hits
				$result =~ s/,//g;            # no. of hits are found for the word NEAR goodword (the one it matches)
                                $factor = 1;
                                if($result ne "")
				{$factor = $result/100000; }
			        if(exists $ldoce_good_hash{$k}) {$factor *=2;} # Double the factor if the word is in the LDOCE hash
				if($factor > $max ) {$factor=$max;}       # Check for the threshold value
                                $factor_cache{$k} = $factor;
				$good_cnt += $factor;                     #Increment the good count
				$def =~ s/ $goodarr[$i] / /; 		 
				$flag = 1;
				$remg = $goodarr[$i];                     # Output details to the trace file			       
			    }
			}
			else
			{
			    last;
			}		
		    }
		    $def = $deaf;
		    $bflag =0;
		    for($i=0;$i<@badarr;$i++)
		    {
			if($bflag==0)
			{
			    if($def =~ m/ $badarr[$i] /)              #compare words with badword list   
			    {
				$bad_cache{$k}++;
				$result = get_hits($k,$badarr[$i]);   # use of the WEB-READER interface to get no.of hits 
				$result =~ s/,//g;               # no. of hits are found for the word NEAR badword (the one it matches)
                                $factor = 1;
                                if($result ne "")
				{ $factor = $result/100000;}            
				if(exists $ldoce_bad_hash{$k}) {$factor *=2;} # double the factor if the word is in LDOCE hash
				if($factor > $max ) {$factor=$max;}       # Check for threshold  
				$factor_cache{$k} = $factor;
				$bad_cnt += $factor;                      # Increment the bad count
				$def =~ s/ $badarr[$i] / /; 		 
				$bflag=1;
				$remb = $badarr[$i];                      # Output the details to the trace file
			    }
			}
			else
			{
			    last;
			}
		    }	
		    print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt  ";
		    if($flag == 1) {print TRACE "   goodword = $remg ";}   # print the words selected in the trace file		
                   if($bflag == 1) {print TRACE "   badword = $remb ";}
                }# if not verb
	      }# end of if(adjective | adverb)	           
	    }# end of if($ff = 0)
	}# end of for 
	foreach $k(keys %no_hash)                                  # process the hash with 'no' near the words in the same way
        {                                                          # except that increment the counts oppositely
            $ff = 0;
	    if( exists $good_cache{$k})
	    {
		print TRACE "\nword = $k ";                        # Look out first for the data in the cache
		$ff = 1;
		$bad_cnt+=$factor_cache{$k};
		print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
		print TRACE "   badword = not $k ";
		next;
	    }
	    if(exists $bad_cache{$k})
	    {
		print TRACE "\nword = $k ";
		$ff = 1;
		$good_cnt+=$factor_cache{$k};                      # Look out for the data first in the cache 
		print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
		print TRACE "   goodword = not $k ";
		next;
	    }
	    


	    for($ll=0;$ll<@goodarr;$ll++)
	    {
		if($k eq $goodarr[$ll])
		{
		    print TRACE "\nword = $k ";
		    $ff = 1;
		    $good_cache{$k}++;
		    $result = get_hits($k,$goodarr[$ll]);    # use of the WEB-READER interface to get no.of hits
		    $result =~ s/,//g;                     # no. of hits are found for the word NEAR goodword (the one it matches)
                    $factor = 1;
                    if($result ne "")
		    {$factor = $result/100000;}
		    if(exists $ldoce_good_hash{$k}) {$factor *=2;}
		    if($factor > $max ) {$factor=$max;}          # check for threshold
		    $factor_cache{$k} = $factor;      
		    $bad_cnt += $factor;                         # Increment the badcount because the word is 'no' good -- means bad
		    print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
		    print TRACE "   badword = not $k ";
		    last;
		}
	    }
	    for($ll=0;$ll<@badarr;$ll++)
	    {
		if($k eq $badarr[$ll])
		{
		    print TRACE "\nword = $k ";
		    $ff = 1;
		    $bad_cache{$k}++;
		    $result = get_hits($k,$badarr[$ll]);       # use of the WEB-READER interface to get no.of hits               
		    $result =~ s/,//g;                           # no. of hits are found for the word NEAR badword (the one it matches)
                    if($result eq "")
                    {
			$result = 100000;
                    }
                    else
                    { 
		        $factor = $result/100000;
                    } 
		    if(exists $ldoce_bad_hash{$k}) {$factor *=2;}  # if in LDOCE , double the factor
                    if($factor > $max ) {$factor=$max;}             
		    $factor_cache{$k} = $factor;         
		    $good_cnt += $factor;                          # Increment the good count
		    print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
		    print TRACE "   goodword = $k ";               # Output details to the trace file
		    last;
		}
		
	    }  
            if($ff==0)
            {
		$ans = get_word_info($k);                     # Using the BigMac function to get the details about a word
		$ans =~ s/\s+/ /g;                            # this has defn.pronunciation,part of speech,thes code related words etc.
		$def = '';
		$part = '';
		$ans1 = $ans;
		while($ans1 =~ m/<POS>(.*?)<\/POS>/)                   #find the part of speech of the word
		{
		    $part .= $&; 
		    $ans1 = $'; #'
		}
		
		if($part =~ m/<POS>adjective<\/POS>/ or $part =~ m/<POS>adverb<\/POS>/) #check if the word is adjective or adverb
		{              
                    if(!($part =~ m/<POS>verb<\/POS>/))
                    {
			print TRACE "\nword = $k ";
			if($ans =~ m/<RELATED>(.*?)<WORDS>/)           #split the definition of the word
			{
			    $def .= $1;	
			}
			
			$def =~ s/\s+/ /g;      
			$deaf = $def;
			$flag=0;
			for($i=0;$i<@goodarr;$i++)                         
			{
			    if($flag==0)
			    {
				if($def =~ m/ $goodarr[$i] /)          #compare words with goodword list   
				{   
				    $good_cache{$k}++;
				    $result = get_hits($k,$goodarr[$i]); # use of the WEB-READER interface to get no.of hits
				    $result =~ s/,//g;         # no. of hits are found for the word NEAR goodword (the one it matches) 
                                    $factor = 1;
                                    if($result ne "")
				    {$factor = $result/100000;}
				    if($factor > $max ) {$factor=$max;}
				    if(exists $ldoce_good_hash{$k}) {$factor *=2;} # Double the factor if in LDOCE
				    $factor_cache{$k} = $factor; 
				    $bad_cnt += $factor;
				    $bad_cnt++;                            # Increment the bad count
				    $def =~ s/ $goodarr[$i] / /; 		 
				    $flag = 1;
				    $remg = $goodarr[$i];				  
				}
			    }
			    else
			    {
				last;
			    }		
			}
			$def = $deaf;
			$bflag =0;
			for($i=0;$i<@badarr;$i++)
			{
			    if($bflag==0)
			    {
				if($def =~ m/ $badarr[$i] /)              #compare words with badword list   
				{
				    $bad_cache{$k}++;
				    $result = get_hits($k,$badarr[$i]);  # use of the WEB-READER interface to get no.of hits
				    $result =~ s/,//g;           # no. of hits are found for the word NEAR badword (the one it matches)
                                    $factor = 1;
                                    if($result ne "")
				    {$factor = $result/100000;}
				    if(exists $ldoce_bad_hash{$k}) {$factor *=2;} # Double the factor if the word is in LDOCE hash
				    if($factor > $max ) {$factor=$max;}      # Threshold Check
				    $factor_cache{$k} = $factor;    
				    $good_cnt += $factor;                   # Increment the good count
				    $def =~ s/ $badarr[$i] / /; 	   	 
				    $bflag=1;
				    $remb = $badarr[$i];				  
				}
			    }
			    else
			    {
				last;
			    }
			}	
			print TRACE "\n $k\t\tgoodcnt = $good_cnt    badcnt = $bad_cnt ";
			if($flag == 1) {print TRACE "   badword =  not $remg ";}#Print the good and bad words matches to the Trace file
			if($bflag == 1) {print TRACE "   goodword = not $remb ";}
		    }# if not verb
		}# end of if(adjective | adverb)	           
	    }# end of if($ff==0)
	}# end of for 
    print TRACE "\n-----------------------------\n";
    print TRACE "\nGOOD COUNT = $good_cnt";
    print TRACE "\nBAD COUNT  = $bad_cnt";
    print TRACE "\n-----------------------------\n";
    if($bad_cnt ==0)                                 # If no bad words then review is positive
    {   
	print  ("\tClassified as Positive\n");
	$positive++;
    }
    else 
    {
	$review= $good_cnt/$bad_cnt;
	if($review >= 1.75)                          # Check for the positive mark
	{
	    print ("\tClassified as Positive\n");
	    $positive++;
	}
	elsif($review <= 1.5)                        # Check for the negative mark
	{
	    print ("\tClassified as Negative\n");
	    $negative++;
	}
	else                                         # Else the review is undecided
	{
	    print ("\tClassified as UNDECIDED\n");
	    $no_decision++;
	}
    }
    close REVIEW;                                    # Close the file

}

